/*
 this file was changed or created for the DOS32 library for DJGPP on 21.9.1996
 new created files are copyright 1996 by C.Lageman, see docs.doc for details
*/
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
/*   Startup code
 *
 *   eip	according to DOS32 header
 *   ds,es,fs,
 *   gs,ss	32-bit data segment program
 *   esp        our stack
 *   <others>   All unspecified registers have unspecified values in them.
 *****************************************************************************/

	.file "crt0.s"

        .comm   ___dos32_prealloced_dma, 64
        .comm   ___dos32_prog_base, 4
        .comm   ___exe_length,   4
	.comm	___psp_address,  4
	.comm	___env_address,  4
	.comm	___dos_argv0,	 4
	.comm	___dos32_dos_buffer, 4
	.comm	___heap_max,	 4
	.comm	___heap_start,	 4
	.comm	___heap_top,	 4
        .comm   ___stack_top,    4
	.comm	___dos32_version,2
	.comm	___dos32_ds,	 2
	.comm	___dos32_cs,	 2
	.comm	___dos32_zero,	 2
	.comm	___dos32_dos_buffer_seg, 2
	.comm	___dos32_system, 1


	.data

	.long	___libc_ident_string

	.long	_main


	.text

	.globl	start
start:
/*  check dos version  */
        movw    $0x3306,%ax
        int     $0x21
        xchgb   %bh,%bl
        movl    $err3,%edx
        cmpw    $0x031E,%bx  /* version 3.30 */
        jb      error_exit

	movl	$edata, %edi		/* set all BSS bytes to zero */
	movl	$end, %ecx
	subl	%edi, %ecx
	xorl	%eax, %eax		/* Zero fill value */
	shrl	$2, %ecx		/* div 4 Longwords not bytes */
	cld
	rep
	stosl

/* get system information (env,psp,selectors etc.) */
	movw	%cs,___dos32_cs
	movw	%ds,___dos32_ds
        movl    %esp,___stack_top

	movw	$0xee00,%ax
        int     $0x31
	movw	%ax,___dos32_version
	movb	%dl,___dos32_system
	movw	%bx,___dos32_zero

	movw	$0xee02,%ax
        int     $0x31
	movl	%ebx,___dos32_prog_base
	movl	%edx,___exe_length
	movl	%ecx,___dos_argv0
	movl	%edi,___env_address
	movw	%ax,___dos32_dos_buffer_seg
	movl	%esi,___psp_address
        andl    $0xffff,%eax
        shll    $4,%eax
	subl	%ebx,%eax
	movl	%eax,___dos32_dos_buffer

/*  alloc memory & dma buffers */

        xorl    %ecx,%ecx
        movw    $0xEE41,%ax
        movb    __crt0_alloc_dma,%cl
        movl    $___dos32_prealloced_dma,%edi
        jecxz   2f
        cmpb    $8,%cl
        ja      dma_error2
1:      int     $0x31
        jc      dma_error
        movl    %ebx,(%edi)
        movl    %edx,4(%edi)
        addl    $8,%edi
        loop    1b
2:
        xorl    %edx,%edx
	movw	$0xee42,%ax
	decl	%edx
        int     $0x31
        testb   $0x40,__crt0_startup_flags+1
        jnz     3f
        testb   $0x20,__crt0_startup_flags+1
        movl    $err2,%ecx
        jz      1f
        movl    __crt0_alloc_mem,%edx
        cmpl    %eax,%edx
        ja      error_exit
        pushl   %edx
        jmp     2f
1:      subl    __crt0_alloc_mem,%eax
	jc	error_exit
        pushl   %eax
2:
        movw    $0xee40,%ax
        int     $0x31
	movl	$err1,%ecx
	jc	error_exit
	movw	$0xee42,%ax
        popl    %edx               /* reserve_mem */
        int     $0x31
	jc	error_exit
3:      mov     %edx,___heap_start
        mov     %eax,%ecx
	mov	%edx,___heap_top
	add	%edx,%eax
	mov	%eax,___heap_max
        movl    __crt0_startup_flags,%eax
        testb   $0x20,%al
        jz      1f
        movl    %edx,%edi
        shrl    $2,%ecx
        testb   $0x40,%al
        movl    $0xdeadbeef,%eax
        jnz     2f
        xorl    %eax,%eax
2:      jecxz   1f
3:      movl    %eax,(%edi)
        addl    $4,%edi
        decl    %ecx
        jnz     3b
1:
	call	___crt1_startup

	jmp	exit

/*----------------------------------------------------------------------------*/

dma_error2:
        movl    $err4,%ecx
dma_error:
        movl    $err5,%ecx
error_exit:
        movl    $errmsg,%edx
        movb    $9,%ah
        int     $0x21
        movl    %ecx,%edx
        int     $0x21
        movl    $crlf,%edx
        int     $0x21
        movb    $1,%al
        jmp     exit

	.global __exit
__exit:
	movb	4(%esp), %al
exit:
	movb	$0x4c,%ah
	int	$0x21



errmsg:
        .ascii  "STARTUP ERROR: $"
err1:
	.ascii	"memory allocation error$"
err2:
	.ascii	"not enough memory$"
err3:
        .ascii  "wrong DOS version (minimum: 3.3)$"
err4:
        .ascii  "too much dma buffers requested (>8)$"
err5:
        .ascii  "can't alloc dma buffer (out of mem ?)$"
crlf:
	.byte	13,10
	.ascii	"$"
