/*
 Blobs 2D v.1.4
 (c) SANCTION
 coding: cohnen
 date: 23.5.96 (v. 1.0)

 documentation and
 release date 6.1.97

 features:
 + fake blobs by blobshading
 + negativ blobs
 + background distortion or logo

*/

#include <stdio.h>
#include <dos.h>
#include <math.h>

#include "defs.h"
#include "ll_kbd.h"

// vars of gr_dos
extern type_word X_RES;
extern type_word Y_RES;
extern char *screen;

// Map for blob shadebob
static char *bob;

// Structure for blob informatin
typedef struct
{
	float x,y;    // x-,y-position
	float dx,dy;  // x-,y-translation
} P;

static P p[80]; 	// Hold max 80 blob information
static int bnum=0;	// number of blobs

static char *texture=NULL;  // background

static int lasttime=0;

/*
  calc shadeblob with blobfunction
  f. gives you intensity at postion x,y
  for one blob
*/
static int BlobFunc (int x,int y)
{
    int distX,distY;
    int r,temp,field;
    int r2;
    int i;

    field = 0;
    distX = x-32 ;
    distY = y-32 ;
    r  = distX*distX+distY*distY;
    r2 = 32*32;
    if (r < r2) {
	    temp = (1024 - (1024*r/r2));
            field +=temp*temp;
    }
field>>=13;
return field;

}

void doBlob2D(char *scr,int time)
{
	blob2d(scr,time-lasttime,time);
	lasttime=time;
}

#define xMax (320-40)
#define xMin (40 )
#define yMax (200-40)
#define yMin (40)
int bk=0;

/*
 main blob
  screen = framebuffer address
  o = movement counter
  time = actual time

  ____
  clear framebuffer or copy background pic
  calc new blobpositions
  set positive and negative blobs doing shadebobs
*/
void blob2d(char *screen,int o,int time)
{
	int i,x,y,pos;
	float off;
	int b;
	off=o;

	if (time>300==1)
    	memcpy(screen,texture,64000);
	else
		memset(screen,127,64000);

	b=time/20;
	if (b>bnum) b=bnum;

	for(i=0;i<b;i++) {
		p[i].x+=p[i].dx*off; p[i].y+=p[i].dy*off;
		if (p[i].x>=xMax) {  p[i].x=xMax-(p[i].x-xMax);  p[i].dx=-p[i].dx; }
		if (p[i].x<xMin) {  p[i].x=xMin-(p[i].x-xMin);  p[i].dx=-p[i].dx; }
		if (p[i].y>=yMax) {  p[i].y=yMax-(p[i].y-yMax);  p[i].dy=-p[i].dy; }
		if (p[i].y<yMin) {  p[i].y=yMin-(p[i].y-yMin);  p[i].dy=-p[i].dy; }
		 if(i%2==0)
		 	putBob(screen,(int)p[i].x,(int)p[i].y);
		 else
		 	subBob(screen,(int)p[i].x,(int)p[i].y);
	}
}

/*
  put positive 64x64 shadebob
*/
void putBob(char *screen,int x,int y)
{
	int a,c;
	char *b;
	int h;
	b=bob;
	screen+=(x-32)+(y-32)*X_RES;
	for(a=0;a<64;a++) {
 		for(c=0;c<64;c++) {
			h=*screen+ (*b++);
			*screen++ =FKT_MIN(255,h );
		}
		screen+=320-64;
	}
}
/*
  put negative 64x64 shadebob
*/

void subBob(char *screen,int x,int y)
{
	int a,c;
	char *b;
	int h;
	b=bob;
	screen+=(x-32)+(y-32)*X_RES;
	for(a=0;a<64;a++) {
 		for(c=0;c<64;c++) {
			h=*screen- (*b++);
			*screen++ =FKT_MAX(1,h );
		}
		screen+=320-64;
	}
}


void initBlob2D()
{

	int i,f,q,x,y;
	type_palette texpal;
	lasttime=0;
	bob=(char *)malloc(64*64);

	// calc blob shadebob with blob function
	for (x=0;x<64;x++)
   		for (y=0;y<64;y++)
			bob[y*64+x]=BlobFunc(x,y);

  	// init blob positions
  	bnum=0;
	for (i=0;i<10;i++)
	{
		p[i].x=40+rand()%240;
		p[i].y=40+rand()%120;
		p[i].dx=-1.01+2*(float)(rand()%10)/10;
		p[i].dy=-1.01+2*(float)(rand()%10)/10;
		bnum++;
	}

	texture=(char *)calloc(1,320*200);
	// load colors
	load_PCX_FILE("blob.pcx",texture,256,256,(char *)&texpal);
	set_pal(texpal);  // set pal of pcx-pic
	load_PCX_FILE("back.pcx",texture,320,200,(char *)&texpal);
	X_RES=320;Y_RES=200;

}


int main(void)
{
	int time=0,frames=0,frametime=0,runtime=0;
	static char *scrpointer;
	static char vscreen[320*200];

	srand();
	set_graphics_mode(320,200);
	scrpointer=&vscreen;
	initBlob2D();

	kbdInit();
	kbdSetMode(ABSOLUTE);
	InitTimer(100);

	do {
		time=GetCounter();
		runtime=time;

	    doBlob2D(scrpointer,time);
		dump(scrpointer);

		frames++;
		if(runtime>frametime+100)
		{
			gotoxy(0,20);
			printf("frames %d\n",frames);
			frametime=runtime;
			frames=0;
		}

	} while (!kbdKeyIs(_ESC));

	RestoreTimer();
	kbdReset();
	exit_graphics();
	free(bob);
	free(texture);
	return(0);
}
